#!ruby -Ks
=begin rdoc
=gakidb.rb
== Overview
 KL̎g̃f[^x[XNX

== Usage
 XNvgrequire邱ƂɂA
 GakiDbNXgpo܂B

 ̃XNvĝsꍇAȉ̂悤ȊłB
 % gakidb.rb [options] Jnԍ
 [options]
 -t       g[Ne\
 -n       \邩(default 5)
 -c       csvőSĕ\
 -r       weboRōŐṼf[^擾
== Example
 % gakidb.rb -n 10 500
 500-509̃^Cg\

== Author
 ghiaccio@plala.to

=end

require "kconv"
require "net/http"
require "getopts"

$KCODE='s'

#KL̎gf[^x[XNX
class GakiDb
  #[JLbV
  Csvfile = "gaki.csv"

  #f[^ǂݍŏ
  #network .. lbgoRōXV邩ǂ
  def initialize(network = nil)
    @db = Array.new
    if network or not test(?r, Csvfile)
      get_network
    end
    load_csv(Csvfile)
  end

  #lbg[Nf[^擾A[Jɕۑ
  def get_network
    #csv_E[h
    host = "ghia.chu.jp"
    uri = "/wiki/getcsv.cgi"

    buf = ""
    Net::HTTP.start(host, 80) do |http|
      response , = http.get(uri)
      buf << response.body
    end
    open(Csvfile, "w") do |f|
      f << Kconv.tosjis(buf)
    end
  end

  #csvt@Cǂݍ
  def load_csv(csvfile)
    open(csvfile) do |f|
      buf = f.read
      buf.each_line do |line|
	no, day, opening, talk = Kconv.tosjis(line).chomp.split(",")
	@db[no.to_i] = GakiItem.new(no, day, opening, talk)
      end
    end
  end

  #傫Ԃ
  def size
    return @db.size
  end

  def lastupdate
    File.ctime(Csvfile)
  end
  
  #csv`ɂďo
  def print_csv
    @db.each do |item|
      if item
        print item.to_csv + "\n"
      end
    end
  end

  #I[vjO\
  #start - final ʂԍw͈
  def no_opening(start = 1, final = nil)
    start = (start < @db.size) ? start : @db.size - 1
    final = (final and final < @db.size ) ? final : @db.size - 1

    if @db[start] and @db[final]
      printf("%s-%s\n", @db[start].day, @db[final].day)
    end
    start.upto(final) do |no|
      if @db[no]
        print format("%s %s\n", @db[no].no, @db[no].opening)
      else
        print format("%d not found\n", no)
      end
    end
  end

  #g[Ne݂ŕ\
  #start - final ʂԍw͈
  def no_opening_talk(start = 1, final = nil)
    start = (start < @db.size) ? start : @db.size - 1
    final = (final and final < @db.size ) ? final : @db.size - 1
    start.upto(final) do |no|
      print format("%s %s\n", @db[no].no, @db[no].opening)
      print format("g[N %s\n", @db[no].talk)
    end
  end

  #Ō
  def time_to_item(time)
    timestr = time.strftime("%Y/%m/%d")
    @db.each do |item|
      if item and item.day == timestr
        return item
      end
    end
    return nil
  end

  #ԍACeԂ
  def no_to_item(no)
    return @db[no]
  end
  
  #X̃ACeێNX -------------------------------------
  class GakiItem
    def initialize(no, day, opening, talk)
      @day = day
      @opening = opening
      @talk = talk
      @no = no
    end
    
    def to_csv
      format("%s,%s,%s,%s", @no.to_s, @day, @opening, @talk)
    end

    attr_accessor(:day, :opening, :talk, :no)
  end

end

#̃XNvggĂ΂ꂽꍇ̃C
if $0 =~ /gakidb.rb/

  USAGE =<<-EOS
% gakidb.rb [options] start_no
[options]
-t       talk detail
-n       no of print(default 5)
-c       csv all mode
-r       data refresh from web mode
EOS

  gdb = GakiDb.new
  #`FbN
  if not getopts("thcr", "n:5") or (not $OPT_c and not $OPT_r and not ARGV[0])
    print USAGE
    printf("\ndatabase max size: %d\n", gdb.size)
    printf("last update: %s\n", gdb.lastupdate.strftime("%Y/%m/%d"))
    exit
  end

  start = ARGV[0].to_i
  final = start + $OPT_n.to_i - 1

  #csv[h̎AS\ďI
  if $OPT_c
    gdb.print_csv
  elsif $OPT_r
    gdb = GakiDb.new(true)
    print "data refresh done\n"
  else
    if $OPT_t
      #g[Ne\[h
      print "-" * 16 + "=" * 16 + "-" * 16 + "\n"
      gdb.no_opening_talk(start, final)
    else
      #^Cĝ݃[h
      gdb.no_opening(start, final)
    end
  end
  
end
